{{
  InkJet Starter Code
  with dummy ChrSet data
  Fred Kerber
}}

CON
        _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000
        MaxMsgLen = 70
        OneUS = _xinfreq / 1_000_000                                        'Use the CON settings to get correct micro seconds
        OneMS = _xinfreq / 1_000                                            'Use the CON settings to get the correct milli seconds.
        FontHeight = 12
        FontWidth = 12
VAR
  

OBJ
    vga           : "vga_text"                                              'VGA output (when this goes into an obj, this will be removed)
  
PUB Start | MsgLen, MsgIndex, CharData, BitIndex 
  vga.start(16)                                                             'Start the VGA driver  (32x14)
  MsgLen := STRSIZE(@Message) - 1                                           'Get the length of the message
  repeat MsgIndex from 0 to MsgLen                                          'For each Char in the message
    vga.out(BYTE[@Message][MsgIndex])                                       'output it to the vga screen (Visual Check of the message)
  vga.out($0D)                                                              'CRLF to move to next line
    
  repeat MsgIndex from 0 to MsgLen                                          'For each char in the message
     CharData := WORD[@ChrSet][(BYTE[@Message][MsgIndex] - 32) * 12]        'Using Message[MsgIndex] as index into CharSet, get this char's 1st word
     vga.bin(CharData,16)                                                   'Print the bin so we can see what we are looking for
     vga.out($20)                                                           'and a space
     vga.hex(CharData,4)                                                    'and the hex value (verifies correct value from ChrSet data)
     vga.out($0d)                                                           'CRLF to the next line
    
     repeat BitIndex from 15 to 0                                           'For each bit in CharData
       vga.bin(CharData[BitIndex],1)                                        'output it's value (should mirror BIN above, but nope...

     vga.out($0d)                                                           'Ok, reset for another line
   
     repeat BitIndex from 15 to 0                                           'Try 2, for each bit in CharData
       if CharData[BitIndex] == 0                                           'If it's a 0 then
          vga.out($4F)                                                      'output an O
       else                                                                 'Otherwise
          vga.out($58)                                                      'output an X

     vga.out($0d)                                                           'Reset for next Char

  vga.str(string("DONE"))                                                   'Printed to know we got this far and we're done  

DAT
Message BYTE    "HI!",0
        BYTE(MaxMsgLen - 6)
ChrSet  WORD    $2020, $2121, $2222, $2323, $2424, $2525, $2626, $2727, $2828, $2929, $2A2A, $2B2B      '       $20     CHR$(32)
        WORD    $2121, $2222, $2323, $2424, $2525, $2626, $2727, $2828, $2929, $2A2A, $2B2B, $2C2C      '!      $21     CHR$(33)
        WORD    $2222, $2323, $2424, $2525, $2626, $2727, $2828, $2929, $2A2A, $2B2B, $2C2C, $2D2D      '"      $22     CHR$(34)
        WORD    $2323, $2424, $2525, $2626, $2727, $2828, $2929, $2A2A, $2B2B, $2C2C, $2D2D, $2E2E      '#      $23     CHR$(35)
        WORD    $2424, $2525, $2626, $2727, $2828, $2929, $2A2A, $2B2B, $2C2C, $2D2D, $2E2E, $2F2F      '$      $24     CHR$(36)
        WORD    $2525, $2626, $2727, $2828, $2929, $2A2A, $2B2B, $2C2C, $2D2D, $2E2E, $2F2F, $3030      '%      $25     CHR$(37)
        WORD    $2626, $2727, $2828, $2929, $2A2A, $2B2B, $2C2C, $2D2D, $2E2E, $2F2F, $3030, $3131      '&      $26     CHR$(38)
        WORD    $2727, $2828, $2929, $2A2A, $2B2B, $2C2C, $2D2D, $2E2E, $2F2F, $3030, $3131, $3232      ''      $27     CHR$(39)
        WORD    $2828, $2929, $2A2A, $2B2B, $2C2C, $2D2D, $2E2E, $2F2F, $3030, $3131, $3232, $3333      '(      $28     CHR$(40)
        WORD    $2929, $2A2A, $2B2B, $2C2C, $2D2D, $2E2E, $2F2F, $3030, $3131, $3232, $3333, $3434      ')      $29     CHR$(41)
        WORD    $2A2A, $2B2B, $2C2C, $2D2D, $2E2E, $2F2F, $3030, $3131, $3232, $3333, $3434, $3535      '*      $2A     CHR$(42)
        WORD    $2B2B, $2C2C, $2D2D, $2E2E, $2F2F, $3030, $3131, $3232, $3333, $3434, $3535, $3636      '+      $2B     CHR$(43)
        WORD    $2C2C, $2D2D, $2E2E, $2F2F, $3030, $3131, $3232, $3333, $3434, $3535, $3636, $3737      ',      $2C     CHR$(44)
        WORD    $2D2D, $2E2E, $2F2F, $3030, $3131, $3232, $3333, $3434, $3535, $3636, $3737, $3838      '-      $2D     CHR$(45)
        WORD    $2E2E, $2F2F, $3030, $3131, $3232, $3333, $3434, $3535, $3636, $3737, $3838, $3939      '.      $2E     CHR$(46)
        WORD    $2F2F, $3030, $3131, $3232, $3333, $3434, $3535, $3636, $3737, $3838, $3939, $3A3A      '/      $2F     CHR$(47)
        WORD    $3030, $3131, $3232, $3333, $3434, $3535, $3636, $3737, $3838, $3939, $3A3A, $3B3B      '0      $30     CHR$(48)
        WORD    $3131, $3232, $3333, $3434, $3535, $3636, $3737, $3838, $3939, $3A3A, $3B3B, $3C3C      '1      $31     CHR$(49)
        WORD    $3232, $3333, $3434, $3535, $3636, $3737, $3838, $3939, $3A3A, $3B3B, $3C3C, $3D3D      '2      $32     CHR$(50)
        WORD    $3333, $3434, $3535, $3636, $3737, $3838, $3939, $3A3A, $3B3B, $3C3C, $3D3D, $3E3E      '3      $33     CHR$(51)
        WORD    $3434, $3535, $3636, $3737, $3838, $3939, $3A3A, $3B3B, $3C3C, $3D3D, $3E3E, $3F3F      '4      $34     CHR$(52)
        WORD    $3535, $3636, $3737, $3838, $3939, $3A3A, $3B3B, $3C3C, $3D3D, $3E3E, $3F3F, $4040      '5      $35     CHR$(53)
        WORD    $3636, $3737, $3838, $3939, $3A3A, $3B3B, $3C3C, $3D3D, $3E3E, $3F3F, $4040, $4141      '6      $36     CHR$(54)
        WORD    $3737, $3838, $3939, $3A3A, $3B3B, $3C3C, $3D3D, $3E3E, $3F3F, $4040, $4141, $4242      '7      $37     CHR$(55)
        WORD    $3838, $3939, $3A3A, $3B3B, $3C3C, $3D3D, $3E3E, $3F3F, $4040, $4141, $4242, $4343      '8      $38     CHR$(56)
        WORD    $3939, $3A3A, $3B3B, $3C3C, $3D3D, $3E3E, $3F3F, $4040, $4141, $4242, $4343, $4444      '9      $39     CHR$(57)
        WORD    $3A3A, $3B3B, $3C3C, $3D3D, $3E3E, $3F3F, $4040, $4141, $4242, $4343, $4444, $4545      ':      $3A     CHR$(58)
        WORD    $3B3B, $3C3C, $3D3D, $3E3E, $3F3F, $4040, $4141, $4242, $4343, $4444, $4545, $4646      ';      $3B     CHR$(59)
        WORD    $3C3C, $3D3D, $3E3E, $3F3F, $4040, $4141, $4242, $4343, $4444, $4545, $4646, $4747      '<      $3C     CHR$(60)
        WORD    $3D3D, $3E3E, $3F3F, $4040, $4141, $4242, $4343, $4444, $4545, $4646, $4747, $4848      '=      $3D     CHR$(61)
        WORD    $3E3E, $3F3F, $4040, $4141, $4242, $4343, $4444, $4545, $4646, $4747, $4848, $4949      '>      $3E     CHR$(62)
        WORD    $3F3F, $4040, $4141, $4242, $4343, $4444, $4545, $4646, $4747, $4848, $4949, $4A4A      '?      $3F     CHR$(63)
        WORD    $4040, $4141, $4242, $4343, $4444, $4545, $4646, $4747, $4848, $4949, $4A4A, $4B4B      '@      $40     CHR$(64)
        WORD    $4141, $4242, $4343, $4444, $4545, $4646, $4747, $4848, $4949, $4A4A, $4B4B, $4C4C      'A      $41     CHR$(65)
        WORD    $4242, $4343, $4444, $4545, $4646, $4747, $4848, $4949, $4A4A, $4B4B, $4C4C, $4D4D      'B      $42     CHR$(66)
        WORD    $4343, $4444, $4545, $4646, $4747, $4848, $4949, $4A4A, $4B4B, $4C4C, $4D4D, $4E4E      'C      $43     CHR$(67)
        WORD    $4444, $4545, $4646, $4747, $4848, $4949, $4A4A, $4B4B, $4C4C, $4D4D, $4E4E, $4F4F      'D      $44     CHR$(68)
        WORD    $4545, $4646, $4747, $4848, $4949, $4A4A, $4B4B, $4C4C, $4D4D, $4E4E, $4F4F, $5050      'E      $45     CHR$(69)
        WORD    $4646, $4747, $4848, $4949, $4A4A, $4B4B, $4C4C, $4D4D, $4E4E, $4F4F, $5050, $5151      'F      $46     CHR$(70)
        WORD    $4747, $4848, $4949, $4A4A, $4B4B, $4C4C, $4D4D, $4E4E, $4F4F, $5050, $5151, $5252      'G      $47     CHR$(71)
        WORD    $4848, $4949, $4A4A, $4B4B, $4C4C, $4D4D, $4E4E, $4F4F, $5050, $5151, $5252, $5353      'H      $48     CHR$(72)
        WORD    $4949, $4A4A, $4B4B, $4C4C, $4D4D, $4E4E, $4F4F, $5050, $5151, $5252, $5353, $5454      'I      $49     CHR$(73)
        WORD    $4A4A, $4B4B, $4C4C, $4D4D, $4E4E, $4F4F, $5050, $5151, $5252, $5353, $5454, $5555      'J      $4A     CHR$(74)
        WORD    $4B4B, $4C4C, $4D4D, $4E4E, $4F4F, $5050, $5151, $5252, $5353, $5454, $5555, $5656      'K      $4B     CHR$(75)
        WORD    $4C4C, $4D4D, $4E4E, $4F4F, $5050, $5151, $5252, $5353, $5454, $5555, $5656, $5757      'L      $4C     CHR$(76)
        WORD    $4D4D, $4E4E, $4F4F, $5050, $5151, $5252, $5353, $5454, $5555, $5656, $5757, $5858      'M      $4D     CHR$(77)
        WORD    $4E4E, $4F4F, $5050, $5151, $5252, $5353, $5454, $5555, $5656, $5757, $5858, $5959      'N      $4E     CHR$(78)
        WORD    $4F4F, $5050, $5151, $5252, $5353, $5454, $5555, $5656, $5757, $5858, $5959, $5A5A      'O      $4F     CHR$(79)
        WORD    $5050, $5151, $5252, $5353, $5454, $5555, $5656, $5757, $5858, $5959, $5A5A, $5B5B      'P      $50     CHR$(80)
        WORD    $5151, $5252, $5353, $5454, $5555, $5656, $5757, $5858, $5959, $5A5A, $5B5B, $5C5C      'Q      $51     CHR$(81)
        WORD    $5252, $5353, $5454, $5555, $5656, $5757, $5858, $5959, $5A5A, $5B5B, $5C5C, $5D5D      'R      $52     CHR$(82)
        WORD    $5353, $5454, $5555, $5656, $5757, $5858, $5959, $5A5A, $5B5B, $5C5C, $5D5D, $5E5E      'S      $53     CHR$(83)
        WORD    $5454, $5555, $5656, $5757, $5858, $5959, $5A5A, $5B5B, $5C5C, $5D5D, $5E5E, $5F5F      'T      $54     CHR$(84)
        WORD    $5555, $5656, $5757, $5858, $5959, $5A5A, $5B5B, $5C5C, $5D5D, $5E5E, $5F5F, $6060      'U      $55     CHR$(85)
        WORD    $5656, $5757, $5858, $5959, $5A5A, $5B5B, $5C5C, $5D5D, $5E5E, $5F5F, $6060, $6161      'V      $56     CHR$(86)
        WORD    $5757, $5858, $5959, $5A5A, $5B5B, $5C5C, $5D5D, $5E5E, $5F5F, $6060, $6161, $6262      'W      $57     CHR$(87)
        WORD    $5858, $5959, $5A5A, $5B5B, $5C5C, $5D5D, $5E5E, $5F5F, $6060, $6161, $6262, $6363      'X      $58     CHR$(88)
        WORD    $5959, $5A5A, $5B5B, $5C5C, $5D5D, $5E5E, $5F5F, $6060, $6161, $6262, $6363, $6464      'Y      $59     CHR$(89)
        WORD    $5A5A, $5B5B, $5C5C, $5D5D, $5E5E, $5F5F, $6060, $6161, $6262, $6363, $6464, $6565      'Z      $5A     CHR$(90)
        WORD    $5B5B, $5C5C, $5D5D, $5E5E, $5F5F, $6060, $6161, $6262, $6363, $6464, $6565, $6666      '[      $5B     CHR$(91)
        WORD    $5C5C, $5D5D, $5E5E, $5F5F, $6060, $6161, $6262, $6363, $6464, $6565, $6666, $6767      '\      $5C     CHR$(92)
        WORD    $5D5D, $5E5E, $5F5F, $6060, $6161, $6262, $6363, $6464, $6565, $6666, $6767, $6868      ']      $5D     CHR$(93)
        WORD    $5E5E, $5F5F, $6060, $6161, $6262, $6363, $6464, $6565, $6666, $6767, $6868, $6969      '^      $5E     CHR$(94)
        WORD    $5F5F, $6060, $6161, $6262, $6363, $6464, $6565, $6666, $6767, $6868, $6969, $6A6A      '_      $5F     CHR$(95)
        WORD    $6060, $6161, $6262, $6363, $6464, $6565, $6666, $6767, $6868, $6969, $6A6A, $6B6B      '`      $60     CHR$(96)
        WORD    $6161, $6262, $6363, $6464, $6565, $6666, $6767, $6868, $6969, $6A6A, $6B6B, $6C6C      'a      $61     CHR$(97)
        WORD    $6262, $6363, $6464, $6565, $6666, $6767, $6868, $6969, $6A6A, $6B6B, $6C6C, $6D6D      'b      $62     CHR$(98)
        WORD    $6363, $6464, $6565, $6666, $6767, $6868, $6969, $6A6A, $6B6B, $6C6C, $6D6D, $6E6E      'c      $63     CHR$(99)
        WORD    $6464, $6565, $6666, $6767, $6868, $6969, $6A6A, $6B6B, $6C6C, $6D6D, $6E6E, $6F6F      'd      $64     CHR$(100)
        WORD    $6565, $6666, $6767, $6868, $6969, $6A6A, $6B6B, $6C6C, $6D6D, $6E6E, $6F6F, $7070      'e      $65     CHR$(101)
        WORD    $6666, $6767, $6868, $6969, $6A6A, $6B6B, $6C6C, $6D6D, $6E6E, $6F6F, $7070, $7171      'f      $66     CHR$(102)
        WORD    $6767, $6868, $6969, $6A6A, $6B6B, $6C6C, $6D6D, $6E6E, $6F6F, $7070, $7171, $7272      'g      $67     CHR$(103)
        WORD    $6868, $6969, $6A6A, $6B6B, $6C6C, $6D6D, $6E6E, $6F6F, $7070, $7171, $7272, $7373      'h      $68     CHR$(104)
        WORD    $6969, $6A6A, $6B6B, $6C6C, $6D6D, $6E6E, $6F6F, $7070, $7171, $7272, $7373, $7474      'i      $69     CHR$(105)
        WORD    $6A6A, $6B6B, $6C6C, $6D6D, $6E6E, $6F6F, $7070, $7171, $7272, $7373, $7474, $7575      'j      $6A     CHR$(106)
        WORD    $6B6B, $6C6C, $6D6D, $6E6E, $6F6F, $7070, $7171, $7272, $7373, $7474, $7575, $7676      'k      $6B     CHR$(107)
        WORD    $6C6C, $6D6D, $6E6E, $6F6F, $7070, $7171, $7272, $7373, $7474, $7575, $7676, $7777      'l      $6C     CHR$(108)
        WORD    $6D6D, $6E6E, $6F6F, $7070, $7171, $7272, $7373, $7474, $7575, $7676, $7777, $7878      'm      $6D     CHR$(109)
        WORD    $6E6E, $6F6F, $7070, $7171, $7272, $7373, $7474, $7575, $7676, $7777, $7878, $7979      'n      $6E     CHR$(110)
        WORD    $6F6F, $7070, $7171, $7272, $7373, $7474, $7575, $7676, $7777, $7878, $7979, $7A7A      'o      $6F     CHR$(111)
        WORD    $7070, $7171, $7272, $7373, $7474, $7575, $7676, $7777, $7878, $7979, $7A7A, $7B7B      'p      $70     CHR$(112)
        WORD    $7171, $7272, $7373, $7474, $7575, $7676, $7777, $7878, $7979, $7A7A, $7B7B, $7C7C      'q      $71     CHR$(113)
        WORD    $7272, $7373, $7474, $7575, $7676, $7777, $7878, $7979, $7A7A, $7B7B, $7C7C, $7D7D      'r      $72     CHR$(114)
        WORD    $7373, $7474, $7575, $7676, $7777, $7878, $7979, $7A7A, $7B7B, $7C7C, $7D7D, $7E7E      's      $73     CHR$(115)
        WORD    $7474, $7575, $7676, $7777, $7878, $7979, $7A7A, $7B7B, $7C7C, $7D7D, $7E7E, $7F7F      't      $74     CHR$(116)
        WORD    $7575, $7676, $7777, $7878, $7979, $7A7A, $7B7B, $7C7C, $7D7D, $7E7E, $7F7F, $8080      'u      $75     CHR$(117)
        WORD    $7676, $7777, $7878, $7979, $7A7A, $7B7B, $7C7C, $7D7D, $7E7E, $7F7F, $8080, $8181      'v      $76     CHR$(118)
        WORD    $7777, $7878, $7979, $7A7A, $7B7B, $7C7C, $7D7D, $7E7E, $7F7F, $8080, $8181, $8282      'w      $77     CHR$(119)
        WORD    $7878, $7979, $7A7A, $7B7B, $7C7C, $7D7D, $7E7E, $7F7F, $8080, $8181, $8282, $8383      'x      $78     CHR$(120)
        WORD    $7979, $7A7A, $7B7B, $7C7C, $7D7D, $7E7E, $7F7F, $8080, $8181, $8282, $8383, $8484      'y      $79     CHR$(121)
        WORD    $7A7A, $7B7B, $7C7C, $7D7D, $7E7E, $7F7F, $8080, $8181, $8282, $8383, $8484, $8585      'z      $7A     CHR$(122)
        WORD    $7B7B, $7C7C, $7D7D, $7E7E, $7F7F, $8080, $8181, $8282, $8383, $8484, $8585, $8686      '{      $7B     CHR$(123)
        WORD    $7C7C, $7D7D, $7E7E, $7F7F, $8080, $8181, $8282, $8383, $8484, $8585, $8686, $8787      '|      $7C     CHR$(124)
        WORD    $7D7D, $7E7E, $7F7F, $8080, $8181, $8282, $8383, $8484, $8585, $8686, $8787, $8888      '}      $7D     CHR$(125)
        WORD    $7E7E, $7F7F, $8080, $8181, $8282, $8383, $8484, $8585, $8686, $8787, $8888, $8989      '~      $7E     CHR$(126)
